Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
AdditiveCipherTemplate< BASE > Class Template Reference

Base class for additive stream ciphers with SymmetricCipher interface. More...

Inheritance diagram for AdditiveCipherTemplate< BASE >:

## Public Types
typedef BASE::PolicyInterface | PolicyInterface
Public Types inherited from AbstractPolicyHolder< AdditiveCipherAbstractPolicy, SymmetricCipher >
typedef AdditiveCipherAbstractPolicy | PolicyInterface
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Public Member Functions
void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes. More...
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Apply keystream to data. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize the cipher. More...
unsigned int | OptimalBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | GetOptimalNextBlockSize () const
| Provides number of ideal bytes to process. More...
unsigned int | OptimalDataAlignment () const
| Provides number of ideal data alignment. More...
bool | IsSelfInverting () const
| Determines if the cipher is self inverting. More...
bool | IsForwardTransformation () const
| Determines if the cipher is a forward transformation. More...
bool | IsRandomAccess () const
| Flag indicating random access. More...
void | Seek (lword position)
| Seeks to a random position in the stream. More...
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length. More...
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length. More...
virtual size_t | DefaultKeyLength () const =0
| Returns default key length. More...
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm. More...
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs. More...
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
virtual size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data. More...
virtual unsigned int | MinLastBlockSize () const
| Provides the size of the last block. More...
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing. More...
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from RandomNumberGenerator
virtual void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values. More...
virtual bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy. More...
virtual byte | GenerateByte ()
| Generate new random byte and return it. More...
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it. More...
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive. More...
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| Generate random bytes into a BufferedTransformation. More...
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes. More...
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array. More...

## Detailed Description

### template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>
class AdditiveCipherTemplate< BASE >

Base class for additive stream ciphers with SymmetricCipher interface.

Template Parameters

  BASE | AbstractPolicyHolder base class

Definition at line 297 of file strciphr.h.

## Member Function Documentation

## ◆ GenerateBlock()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

void AdditiveCipherTemplate< BASE >::GenerateBlock | ( | byte * | output,
|  | size_t | size
| ) |  |
| virtual

Generate random array of bytes.

Parameters

  output | the byte buffer
  size | the length of the buffer, in bytes

All generated values are uniformly distributed over the range specified within the constraints of a particular generator.

Reimplemented from RandomNumberGenerator.

## ◆ ProcessData()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

void AdditiveCipherTemplate< BASE >::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |
| virtual

Apply keystream to data.

Parameters

  outString | a buffer to write the transformed data
  inString | a buffer to read the data
  length | the size of the buffers, in bytes

This is the primary method to operate a stream cipher. For example:

        size_t size = 30;
        byte plain[size] = "Do or do not; there is no try";
        byte cipher[size];
        ...
        ChaCha20 chacha(key, keySize);
        chacha.ProcessData(cipher, plain, size);

You should use distinct buffers for inString and outString. If the buffers are the same, then the data will be copied to an internal buffer to avoid GCC alias violations. The internal copy will impact performance.

See also
  Issue 1088, 36% loss of performance with AES, Issue 1010, HIGHT cipher troubles with FileSource

Implements StreamTransformation.

## ◆ Resynchronize()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

void AdditiveCipherTemplate< BASE >::Resynchronize | ( | const byte * | iv,
|  | int | length = `-1`
| ) |  |
| virtual

Resynchronize the cipher.

Parameters

  iv | a byte array used to resynchronize the cipher
  length | the size of the IV array

Reimplemented from SimpleKeyingInterface.

## ◆ OptimalBlockSize()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

unsigned int AdditiveCipherTemplate< BASE >::OptimalBlockSize | ( |  | ) | const
| inline virtual

Provides number of ideal bytes to process.

Returns
  the ideal number of bytes to process

Internally, the default implementation returns GetBytesPerIteration()

See also
  GetBytesPerIteration() and GetOptimalNextBlockSize()

Reimplemented from StreamTransformation.

Definition at line 340 of file strciphr.h.

## ◆ GetOptimalNextBlockSize()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

unsigned int AdditiveCipherTemplate< BASE >::GetOptimalNextBlockSize | ( |  | ) | const
| inline

Provides number of ideal bytes to process.

Returns
  the ideal number of bytes to process

Internally, the default implementation returns remaining unprocessed bytes

See also
  GetBytesPerIteration() and OptimalBlockSize()

Definition at line 346 of file strciphr.h.

## ◆ OptimalDataAlignment()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

unsigned int AdditiveCipherTemplate< BASE >::OptimalDataAlignment | ( |  | ) | const
| inline virtual

Provides number of ideal data alignment.

Returns
  the ideal data alignment, in bytes

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from StreamTransformation.

Definition at line 351 of file strciphr.h.

## ◆ IsSelfInverting()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

bool AdditiveCipherTemplate< BASE >::IsSelfInverting | ( |  | ) | const
| inline virtual

Determines if the cipher is self inverting.

Returns
  true if the stream cipher is self inverting, false otherwise

Implements StreamTransformation.

Definition at line 355 of file strciphr.h.

## ◆ IsForwardTransformation()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

bool AdditiveCipherTemplate< BASE >::IsForwardTransformation | ( |  | ) | const
| inline virtual

Determines if the cipher is a forward transformation.

Returns
  true if the stream cipher is a forward transformation, false otherwise

Implements StreamTransformation.

Definition at line 359 of file strciphr.h.

## ◆ IsRandomAccess()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

bool AdditiveCipherTemplate< BASE >::IsRandomAccess | ( |  | ) | const
| inline virtual

Flag indicating random access.

Returns
  true if the cipher is seekable, false otherwise

See also
  Seek()

Implements StreamTransformation.

Definition at line 364 of file strciphr.h.

## ◆ Seek()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

void AdditiveCipherTemplate< BASE >::Seek | ( | lword | position | ) |
| virtual

Seeks to a random position in the stream.

Parameters

  position | the absolute position in the stream

See also
  IsRandomAccess()

Reimplemented from StreamTransformation.

## ◆ AlgorithmProvider()

template<class BASE = AbstractPolicyHolder<AdditiveCipherAbstractPolicy, SymmetricCipher>>

std::string AdditiveCipherTemplate< BASE >::AlgorithmProvider | ( |  | ) | const
| inline virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 385 of file strciphr.h.

The documentation for this class was generated from the following file:

- strciphr.h